#include <bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define dout if(dbg) cout

using namespace std;
typedef long long ll;
typedef pair<int, int> pi;
typedef pair<ll, ll> pll;

bool dbg = 0;

ll a[500001];

ll brK[65] = {0}, minDist[65] = {0}; // brKeceva
ll desnoKecevi[65];
ll ksorovi[65];
ll najblizi[500001][65][2]; // za svaki br, najblizi za setovanje b-tog bita (mzd mogu oba

ll mDist(ll a, int bit, int ind)
{
    ll prviVeci = a;
    prviVeci |= (1 << bit);
    if(bit != 0)
        prviVeci -= (a & desnoKecevi[bit-1]);
    ll dist1 = abs(a - prviVeci);
    ll prviManji = a;
    if((1 << bit) > a)
    {
        najblizi[ind][bit][0] = prviVeci;
        najblizi[ind][bit][1] = -1;
        return dist1;
    }
    if(bit != 0)
        prviManji -= (a & desnoKecevi[bit-1]);
    prviManji--;
    ll dist2 = a - prviManji;
    if(dist1 == dist2)
    {
        najblizi[ind][bit][0] = prviVeci;
        najblizi[ind][bit][1] = prviManji;
        return dist1;
    }
    else if(dist1 > dist2)
    {
        najblizi[ind][bit][0] = prviManji;
        najblizi[ind][bit][1] = -1;
        return dist2;
    }
    else
    {
        najblizi[ind][bit][0] = prviVeci;
        najblizi[ind][bit][1] = -1;
        return dist1;
    }
}

int main()
{
    if(!dbg)
    {
        ios::sync_with_stdio(false);
        cin.tie(0);
    }
    desnoKecevi[0] = 1;
    for(int i = 1; i < 64; i++)
        desnoKecevi[i] = ((1<<i) + desnoKecevi[i-1]);

    int n;
    cin >> n;
    int maksBit = 63;
    for(int i = 0; i < n; i++) cin >> a[i];

    for(int b = 0; b <= maksBit; b++)
    {
        for(int i = 0; i < n; i++)
        {
            bool bit = ((a[i] & (1 << b)) > 0);
            brK[b] += bit;
            if(b == 0) ksorovi[b] = bit;
            else ksorovi[b] ^= bit;
        }
    }

    bool imaAnd = false, imaXor = false;
    vector<int> imajuKsor;
    for(int i = 0; i <= maksBit; i++)
    {
        imaAnd |= (brK[i] == n), imaXor |= ksorovi[i];
        if(ksorovi[i]) imajuKsor.pb(i);
    }


    if(imaAnd && imaXor)
    {
        cout << 0;
        return 0;
    }

    for(int b = 0; b <= maksBit; b++)
        for(int i = 0; i < n; i++)
            if((a[i] & (1 << b)) == 0)
                minDist[b] += mDist(a[i], b, i);

    ll minAnd = 1e18;
    for(int b = 0; b <= maksBit; b++)
        minAnd = min(minAnd, minDist[b]);

    vector<int> minimumi;
    for(int b = 0; b <= maksBit; b++)
        if(minDist[b] == minAnd) minimumi.pb(b);

    if(imajuKsor.size() > 1)
    {
        cout << minAnd;
    }
    else if(imajuKsor.size() == 1)
    {
        for(int b : minimumi)
        {
            if(b != imajuKsor[0])
            {
                cout << minDist;
                return 0;
            }
        }
    }
    else
    {
        cout << minDist + 1;
        return 0;
    }
    return 0;
}